css = """
/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * Alternatively, the contents of this file may be used under the terms
 * of the GNU General Public License Version 3, as described below:
 *
 * This file is free software: you may copy, redistribute and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This file is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see http://www.gnu.org/licenses/.
 *
 * Changes
 * - replace Firefox specific css extensions with WebKit css extensions
 * - append FeedView css selectors
 *
 * - Adjusted for Epiphany (Removing footer)
 *
 * Notes:
 *
 * - WCAG 2.0 level AA recommends at least 4.5 for normal text, 3 for large
 *   text. See: https://marijohannessen.github.io/color-contrast-checker/
 *
 * - The @font-face rules try to use locally installed copies of the fonts,
 *   and fallback to the bundled versions. As per W3C recommendation, the
 *   rules include both full font names and PostScript names to assure
 *   proper matching across platforms and installed font formats. See:
 *   https://www.w3.org/TR/css-fonts-3/#font-face-rule
 */

@font-face {
  font-family: ephy-reader-serif;
  src: local('Merriweather'),
       local('Merriweather-Regular'),
       url('ephy-resource:///org/gnome/epiphany/fonts/Merriweather-Regular.otf') format('opentype');
  font-weight: normal;
  font-style: normal;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-serif;
  src: local('Merriweather Italic'),
       local('Merriweather-Italic'),
       local('Merriweather-It'),
       url('ephy-resource:///org/gnome/epiphany/fonts/Merriweather-Italic.otf') format('opentype');
  font-weight: normal;
  font-style: italic;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-serif;
  src: local('Merriweather Bold'),
       local('Merriweather-Bold'),
       local('Merriweather-Bd'),
       url('ephy-resource:///org/gnome/epiphany/fonts/Merriweather-Bold.otf') format('opentype');
  font-weight: bold;
  font-style: normal;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-serif;
  src: local('Merriweather Bold Italic'),
       local('Merriweather-BoldItalic'),
       local('Merriweather-BoldIt'),
       local('Merriweather-BdItalic'),
       local('Merriweather-BdIt'),
       url('ephy-resource:///org/gnome/epiphany/fonts/Merriweather-BoldItalic.otf') format('opentype');
  font-weight: bold;
  font-style: italic;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-sans;
  src: local('Merriweather Sans'),
       local('MerriweatherSans-Regular'),
       url('ephy-resource:///org/gnome/epiphany/fonts/MerriweatherSans-Regular.ttf') format('truetype');
  font-weight: normal;
  font-style: normal;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-sans;
  src: local('Merriweather Sans Italic'),
       local('MerriweatherSans-Italic'),
       local('MerriweatherSans-It'),
       url('ephy-resource:///org/gnome/epiphany/fonts/MerriweatherSans-Italic.ttf') format('truetype');
  font-weight: normal;
  font-style: italic;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-sans;
  src: local('Merriweather Sans Bold'),
       local('MerriweatherSans-Bold'),
       local('MerriweatherSans-Bd'),
       url('ephy-resource:///org/gnome/epiphany/fonts/MerriweatherSans-Bold.ttf') format('truetype');
  font-weight: bold;
  font-style: normal;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-sans;
  src: local('Merriweather Sans Bold Italic'),
       local('MerriweatherSans-BoldItalic'),
       local('MerriweatherSans-BoldIt'),
       local('MerriweatherSans-BdItalic'),
       local('MerriweatherSans-BdIt'),
       url('ephy-resource:///org/gnome/epiphany/fonts/MerriweatherSans-BoldItalic.ttf') format('truetype');
  font-weight: bold;
  font-style: italic;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-mono;
  src: local('Source Code Pro'),
       local('SourceCodePro-Regular'),
       url('ephy-resource:///org/gnome/epiphany/fonts/SourceCodePro-Regular.otf') format('opentype');
  font-weight: normal;
  font-style: normal;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-mono;
  src: local('Source Code Pro Italic'),
       local('SourceCodePro-Italic'),
       local('SourceCodePro-It'),
       url('ephy-resource:///org/gnome/epiphany/fonts/SourceCodePro-It.otf') format('opentype');
  font-weight: normal;
  font-style: italic;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-mono;
  src: local('Source Code Pro Bold'),
       local('SourceCodePro-Bold'),
       local('SourceCodePro-Bd'),
       url('ephy-resource:///org/gnome/epiphany/fonts/SourceCodePro-Regular.otf') format('opentype');
  font-weight: bold;
  font-style: normal;
  font-display: block;
}

@font-face {
  font-family: ephy-reader-mono;
  src: local('Source Code Pro Bold Italic'),
       local('SourceCodePro-BoldItalic'),
       local('SourceCodePro-BoldIt'),
       local('SourceCodePro-BdItalic'),
       local('SourceCodePro-BdIt'),
       url('ephy-resource:///org/gnome/epiphany/fonts/SourceCodePro-Regular.otf') format('opentype');
  font-weight: bold;
  font-style: italic;
  font-display: block;
}


body.sans {
  font-family: ephy-reader-sans, sans-serif;
}

body.serif {
  font-family: ephy-reader-serif, serif;
}

body {
  line-height: 1.45;
  text-rendering: optimizeLegibility;
}

body.light {
  /* Contrast ratio: 10.49 */
  color: #333333;
  background: #efefee;
}

body.dark {
  color: #efefef;
  background: #181818;
}

h1,
h2,
h3,
h4,
h5,
h6 {
  /* Contrast ratio: 4.77 */
  font-weight: bold;
  color: #555555;
  font-family: ephy-reader-serif, serif;
}

body.serif h1,
body.serif h2,
body.serif h3,
body.serif h4,
body.serif h5,
body.serif h6 {
  font-family: ephy-reader-sans, sans-serif;
}


body.dark h1,
body.dark h2,
body.dark h3,
body.dark h4,
body.dark h5,
body.dark h6 {
  color: #999999;
}


tt,
code,
pre {
  font-family: ephy-reader-mono, monospace;
}

hr {
  border: 1px solid #efefef;
}

picture img {
  border-radius: 3px;
}

img {
    display: inline-block !important;
    position: relative !important;
    background-color: white;
}

h1 {
  font-size: 1.6em;
}

h2 {
  font-size: 1.2em;
}

h3 {
  font-size: 1em;
}

a {
  text-decoration: underline;
  font-weight: normal;
}

a,
a:visited,
a:hover,
a:active {
  color: #0095dd;
}

* {
  max-width: 100%;
  height: auto;
}

p,
code,
pre,
blockquote,
ul,
ol,
li,
figure,
.wp-caption {
  margin: 0 0 30px 0;
}

p > img:only-child,
p > a:only-child > img:only-child,
.wp-caption img,
figure img {
  display: block;
}

.caption,
.wp-caption-text,
figcaption {
  font-size: 0.9em;
  font-style: italic;
}

code,
pre {
  white-space: pre-wrap;
}

blockquote {
  padding: 0;
  -webkit-padding-start: 16px;
}

ul,
ol {
  padding: 0;
}

ul {
  -webkit-padding-start: 30px;
  list-style: disc;
}

ol {
  -webkit-padding-start: 30px;
  list-style: decimal;
}

/* Hide elements with common "hidden" class names */
.visually-hidden,
.visuallyhidden,
.hidden,
.invisible,
.sr-only {
  display: none;
}

article, body {
  /*margin: 20px auto;
  width: 640px;*/
  font-size: 18px;
  word-wrap: break-word;
}

body {
  margin: 24px 24px 24px 24px;
}

article {
  margin: auto;
  max-width: 640px;
}

mark {
  padding: 2px;
  margin: -2px;
  border-radius: 3px;
  background: #d7d7d8;
}

body.dark mark {
  background: #282828;
  color: #efefef;
}
"""

dark_mode_css = """
body, table, tbody, tr, td {
  background-color: #181818;
}

body, article, p, h1, h2, h3, h4, h5, h6, h7, table {
  color: white !important;
}
"""

from lxml.html import html5parser, tostring
from gettext import gettext as _
import re

def build_reader_html(og_html, dark_mode=False):
    if not og_html:
        return
    root = html5parser.fromstring(og_html if type(og_html) == str else og_html.decode())
    try:
        article_els = root.xpath(
            '//x:article',
            namespaces={'x': 'http://www.w3.org/1999/xhtml'}
        )
        if len(article_els) == 0:
            article_els = root.xpath(
                '//x:body',
                namespaces={'x': 'http://www.w3.org/1999/xhtml'}
            )
        article_s = tostring(
            article_els[0]
        ).decode().replace('<html:', '<').replace('</html:', '</')
        # article_s = re.sub(r'<article .*?>', article_s, 1, flags=re.IGNORECASE)
        # article_s = re.sub(r'</article>', article_s, 1, flags=re.IGNORECASE)
    except:
        article_s = '<h1><i>'+_('Reader mode unavailable for this site')+'</i></h1>'
    
    return f'<html><head><style>{dark_mode_css if dark_mode else ""}{css}</style><body>{article_s}</body></html>'
